#pragma once

#include "BitStream.h"

#include <vector>

class BufferBitStream : public BitStream
{
public:
    bool isFinished() const override;

    std::vector<unsigned char> peekNextNBytes(unsigned n) const override;

    std::optional<unsigned char> readNextByte() override;

    void setBuffer(const std::vector<unsigned char>& data);

    void writeByte(unsigned char data) override;

    const std::vector<unsigned char>& getBuffer() const
    {
        return mBuffer;
    }

private:
    std::vector<unsigned char> mBuffer;
};
