#pragma once

#include "BitStream.h"

#include "Image.h"

class ImageBitStream : public BitStream
{
public:
    ImageBitStream(Image<unsigned char>* image);

    bool isFinished() const override;

    std::vector<unsigned char> peekNextNBytes(unsigned n) const override;

    std::optional<unsigned char> readNextByte() override;

    void writeByte(unsigned char data) override;

private:
    Image<unsigned char>* mImage{nullptr};
};
