#pragma once

#include <string>
#include <sstream>

namespace Png
{
    inline unsigned char getHighBitCheck()
    {
        return 0x89;
    }

    inline std::vector<unsigned char> getSignature()
    {
        return {13, 10, 26, 10};
    }

    struct IHDRChunk
    {
        unsigned width{0};
        unsigned height{0};
        char bitDepth{0};
        char colorType{0};
        char compressionMethod{0};
        char filterMethod{0};
        char interlaceMethod{0};

        std::string toString() const
        {
            std::stringstream sstr;
            sstr << "width: " << width << "\n";
            sstr << "height: " << height << "\n";
            sstr << "bitDepth: " << (int)bitDepth << "\n";
            sstr << "colorType: " << (int)colorType << "\n";
            sstr << "compressionMethod: " << (int)compressionMethod << "\n";
            sstr << "filterMethod: " << (int)filterMethod << "\n";
            sstr << "interlaceMethod: " << (int)interlaceMethod << "\n";
            return sstr.str();
        }
    };
}

