#pragma once

#include "Image.h"

#include <memory>
#include <string>
#include <filesystem>

using Path = std::filesystem::path;

class BitStream;
class File;

class PngWriter
{
public:
    PngWriter();
    ~PngWriter();

    static std::unique_ptr<PngWriter> Create();

    void setPath(const Path& path);

    void write(const std::unique_ptr<Image<unsigned char> >& image);

private:
    void writeSignature();
    void writeHeader();


    Path mPath;
    Image<unsigned char>* mWorkingImage{nullptr};
    std::unique_ptr<BitStream> mInStream;
    std::unique_ptr<BitStream> mOutStream;
    std::unique_ptr<File> mWorkingFile;
};

using PngWriterPtr = std::unique_ptr<PngWriter>;
